''
'' counter based multiplier, 4 cycles/bit
''
''        Author: Marko Lukat
'' Last modified: 2010/08/23
''       Version: 0.1
''
CON
  _clkmode = client#_clkmode
  _xinfreq = client#_xinfreq

OBJ
  client: "core.con.client.demoboard"
  serial: "FullDuplexSerial"
  
VAR
  long  storage[2]
  
PUB null

  serial.start(31, 30, %0000, 115200)
  waitcnt(clkfreq*5 + cnt)
  
  coginit(7, @secondary, @storage)                      ' start helper cog
  coginit(6, @countiply, @storage)                      ' start multiplier
  repeat until storage[1]                               ' wait for result

  serial.str(string("result: "))                        ' display result
  serial.hex(storage[1], 8)
  serial.tx(13)
  
CON
  mult_pin = 0

  add_frqa_frqa = $80BFF5FA     ' add frqa, frqa
  ror_outa_imm1 = $20FFE801     ' ror outa, #1

  zero = $1FF   ' vscl
  
DAT             org     0                       ' counter based multiplier

countiply       jmpret  $, #:setup              ' once

                mov     frqa, zwei              ' phsa := eins * frqa


                cmp     frqa, eins wc           ' |
        if_c    xor     frqa, eins              ' |
        if_c    xor     eins, frqa              ' |
        if_c    xor     frqa, eins              ' | eins =< frqa

                wrlong  eins, par               '  +0 = inform gate cog

                shr     eins, #16 wz,nr         '  +8   check word[1]
        if_nz   jmp     #:main_32               ' +12   top bit > 15

:main_10        shr     eins, #8 wz,nr          ' +16 = check byte[1]
        if_nz   jmp     #:main_1_               ' +20   top bit > 7


:main__0        mov     phsa, #0                ' +24   clear accumulator
                long    add_frqa_frqa[7]        '       adjust operand
                jmp     #:exit
                
:main_1_        mov     phsa, #0                ' clear accumulator
                long    add_frqa_frqa[15]       ' adjust operand
                jmp     #:exit


:main_32        shr     eins, #24 wz,nr         ' check byte[3]
        if_nz   jmp     #:main_3_               ' top bit > 23


:main__2        mov     phsa, #0                ' clear accumulator
                long    add_frqa_frqa[23]       ' adjust operand
                jmp     #:exit

:main_3_        mov     phsa, #0                ' clear accumulator
                long    add_frqa_frqa[31]       ' adjust operand

:exit           mov     phsa, phsa              ' |
                mov     eins, par               ' |
                add     eins, #4                ' |
                wrlong  phsa, eins              ' | store result

                cogid   cnt                     '
                cogstop cnt                     ' sayonara ...
                

:setup          movs    ctra, #mult_pin         '
                movi    ctra, #%0_01110_000     ' NEGEDGE
                
                jmp     $000                    ' ret

' initialised data and/or presets

eins            long    $89AB
zwei            long    $CDEF

' uninitialised data and/or temporaries

                fit

DAT             org     0                       ' gate pulse generator

secondary       jmpret  $, #:setup              ' once

                rdlong  outa, par wz            '  +0 = get operand
        if_z    jmp     #$-1                    '  +8   we only do non-zero

                nop                             ' +12
                
                rol     outa, ctra              ' +16 = shuffle bit 0 to clock pin
                xor     outa, minus1            ' +20   OR logic, 1: disabled

                long    ror_outa_imm1[15]       '
                long    ror_outa_imm1[16]       ' send out remaining gate bits

                wrlong  zero, par               ' clear operand
                jmp     $000                    ' continue


:setup          or      dira, mult_mask         ' clock bit

                movs    ctra, #mult_pin         '
                movi    ctra, #%0_00100_000     ' NCO single-ended
                movi    phsa, #%1100_0000_0     ' preset (low centres around phase D)
                movi    frqa, #%0100_0000_0     ' clkfreq/4

                jmp     $000                    ' ret
                
' initialised data and/or presets

mult_mask       long    |< mult_pin             ' ouput mask for clock pin
minus1          long    -1

' uninitialised data and/or temporaries

                fit
                
DAT             org     0                       ' pin validation

                res     (mult_pin) >> 5 <# 1

                fit     0
               
DAT